import { renderless, api } from '@opentinyvue/vue-renderless/roles/vue';
import { defineComponent, props, setup } from '@opentinyvue/vue-common';
import Popover from '@opentinyvue/vue-popover';
import { IconChevronDown, IconChevronUp } from '@opentinyvue/vue-icon';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var __vue2_script = defineComponent({
  props: [].concat(props, ["fetchRole", "getEnvInfoSync", "getChangeRoleUrl", "getCustomized", "pushCustomized", "popperAppendToBody"]),
  components: {
    TinyPopover: Popover,
    IconChevronDown: IconChevronDown(),
    IconChevronUp: IconChevronUp()
  },
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "tiny-roles"
  }, [_c("tiny-popover", {
    attrs: {
      "popper-class": "tiny-roles__selector",
      "append-to-body": _vm.popperAppendToBody,
      "disabled": _vm.state.roleList.length === 1,
      "placement": "bottom-start",
      "trigger": "hover"
    },
    on: {
      "show": _vm.show,
      "hide": _vm.hide
    },
    scopedSlots: _vm._u([{
      key: "reference",
      fn: function fn() {
        return [_c("span", [_vm._v(" " + _vm._s(_vm.state.currentRole) + " "), _c(_vm.state.showIcon ? "icon-chevron-down" : "icon-chevron-up", {
          directives: [{
            name: "show",
            rawName: "v-show",
            value: _vm.state.roleList.length > 1,
            expression: "state.roleList.length > 1"
          }],
          tag: "component"
        })], 1)];
      },
      proxy: true
    }]),
    model: {
      value: _vm.state.showPopover,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "showPopover", $$v);
      },
      expression: "state.showPopover"
    }
  }, [_c("div", {
    staticClass: "tiny-roles tiny-roles__selector-body"
  }, [_c("ul", {
    staticClass: "tiny-roles__poplist"
  }, _vm._l(_vm.state.roleList, function(item, key) {
    return _c("li", {
      key,
      staticClass: "tiny-roles__poplist-item",
      class: [_vm.state.currentId === item.roleId ? "is-selected" : ""],
      attrs: {
        "data-value": item.roleId,
        "current-scope": item.currentScope
      },
      on: {
        "click": function click($event) {
          return _vm.changeRole(item);
        }
      }
    }, [_c("span", [_vm._v(_vm._s(item.roleName))])]);
  }), 0)])])], 1);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { pc as default };
